#include "IRLibAll.h"

const int ENABLE = 4; // Festlegung Motorvariablen
const int IN1 = 9;
const int IN2 = 10;
const int IN3 = 5;
const int IN4 = 6;
int duration;//the number of the pulses
boolean crash = false; // Boolsche Variable zur Erkennung einer Kollision

// Infrarot
IRrecvPCI myReceiver(3);
//Create a decoder object
IRdecode myDecoder;

// Ultraschall
int trigger = 11;
int echo = 12;
long dauer = 0;
long entfernung = 0;

void setup() {
  Serial.begin(9600);
  // Motoren
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  pinMode(ENABLE, OUTPUT);
  //Ultraschall
  pinMode(trigger, OUTPUT);
  pinMode(echo, INPUT);

// Infrarot
  delay(2000); while (!Serial); //delay for Leonardo
  myReceiver.enableIRIn(); // Start the receiver
  }

void loop() {
  digitalWrite(trigger, LOW); 
delay(5); 
digitalWrite(trigger, HIGH); 
delay(10);
digitalWrite(trigger, LOW);
dauer = pulseIn(echo, HIGH); 
entfernung = (dauer/2) * 0.03432; 
if (entfernung >= 500 || entfernung <= 0) 
{
Serial.println("Kein Messwert"); 
}
else 
{
Serial.print(entfernung); 
Serial.println(" cm"); 
}
delay(500); 


  // Motoren
  digitalWrite(ENABLE, HIGH);
  int pwm = 100;
  analogWrite(IN1, pwm);
  digitalWrite(IN2, LOW);
  analogWrite(IN3, pwm);
  digitalWrite(IN4, LOW);
  // ich muss die Variable auf Null setzen, damit ich die nächste Messung durchführen kann:
  duration = 0;
  delay(100);

// Infrarot

  //Continue looping until you get a complete signal received
  if (myReceiver.getResults()) {
    myDecoder.decode();           //Decode it
    myDecoder.dumpResults(true);  //Now print results. Use false for less detail
    myReceiver.enableIRIn();      //Restart receiver
    Serial.println("detected");

  }
}


void backUp(){
  digitalWrite(IN2, LOW); // rückwärts fahren
  digitalWrite(IN4, LOW);
  delay(2000);
  digitalWrite(IN2, HIGH); // links drehen, Motor 1 fährt vorwärts, Motor 2 rückwärts
  digitalWrite(IN4, LOW);
  analogWrite(IN1, 200); // Geschwindigkeit auf 200 setzen
  analogWrite(IN3, 200);
  delay(2000);
  analogWrite(IN1, 0); // Geschwindigkeit auf 0 setzen
  analogWrite(IN3, 0);
}

void goForward(int duration, int pwm)
{
  long a, b;
  int dist = 0;
  boolean move = true;
  a = millis();
  do
  {
    long entfernung(); // Während der Fahrt wird immer wieder die Distanz gemessen
    Serial.println(dist);
    if (dist < 10) // Ist sie kleiner als 10 cm wird die Crash Variable auf true gesetzt
    {
      crash = true;
    }
    if (crash == false) // So lange crash gleich false ist, wird gerade aus gefahren
    {
      digitalWrite(IN2, HIGH); // Beide Motoren vorwärts
      digitalWrite(IN4, HIGH);
      analogWrite(IN1, pwm); // Die Geschwindigkeit wird durch den Prozeduraufruf festgelegt, hier beträgt sie für beide Motoren 255
      analogWrite(IN3, pwm);
    }
    if (crash == true) // Wenn ein Crash vorliegt, wird zuerst das Ausweichmanöver aufgerufen…
    {
      backUp();
      crash = false; // … und danach die Crash Variable auf false gesetzt, damit wieder gerade aus gefahren werden kann
    }
    b = millis() - a;
    if (b >= duration)
    {
      move = false;
    }
  }
  while (move != false);
  // Motoren anhalten
  analogWrite(IN1, 0);
  analogWrite(IN3, 0);
}
